/*
 * _gen/svc-Channel_Interface_Group.h - Header for TpSvcChannelInterfaceGroup
 *
 * Copyright (C) 2005, 2006 Collabora Limited
 * Copyright (C) 2005, 2006 Nokia Corporation
 * Copyright (C) 2006 INdT
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CHANNEL_INTERFACE_GROUP_H__
#define __TP_SVC_CHANNEL_INTERFACE_GROUP_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcChannelInterfaceGroup:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcChannelInterfaceGroup TpSvcChannelInterfaceGroup;

/**
 * TpSvcChannelInterfaceGroupClass:
 *
 * The class of TpSvcChannelInterfaceGroup.
 */
typedef struct _TpSvcChannelInterfaceGroupClass TpSvcChannelInterfaceGroupClass;


GType tp_svc_channel_interface_group_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CHANNEL_INTERFACE_GROUP \
  (tp_svc_channel_interface_group_get_type ())
#define TP_SVC_CHANNEL_INTERFACE_GROUP(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CHANNEL_INTERFACE_GROUP, TpSvcChannelInterfaceGroup))
#define TP_IS_SVC_CHANNEL_INTERFACE_GROUP(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CHANNEL_INTERFACE_GROUP))
#define TP_SVC_CHANNEL_INTERFACE_GROUP_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CHANNEL_INTERFACE_GROUP, TpSvcChannelInterfaceGroupClass))


typedef void (*tp_svc_channel_interface_group_add_members_impl) (TpSvcChannelInterfaceGroup *self,
                                                                 const GArray *contacts,
                                                                 const gchar *message,
                                                                 DBusGMethodInvocation *context);
void tp_svc_channel_interface_group_implement_add_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_add_members_impl impl);


/**
 * tp_svc_channel_interface_group_return_from_add_members:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_group_return_from_add_members (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_channel_interface_group_return_from_add_members (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_channel_interface_group_get_all_members_impl) (TpSvcChannelInterfaceGroup *self,
                                                                     DBusGMethodInvocation *context);
void tp_svc_channel_interface_group_implement_get_all_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_all_members_impl impl);


/**
 * tp_svc_channel_interface_group_return_from_get_all_members:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 * @ret1: FIXME: document args in genginterface
 * @ret2: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_group_return_from_get_all_members (DBusGMethodInvocation *dbus_context,
                                                            const GArray *ret,
                                                            const GArray *ret1,
                                                            const GArray *ret2)
;
static inline void
tp_svc_channel_interface_group_return_from_get_all_members (DBusGMethodInvocation *dbus_context,
                                                            const GArray *ret,
                                                            const GArray *ret1,
                                                            const GArray *ret2)
{
  dbus_g_method_return (dbus_context, ret, ret1, ret2);
}
typedef void (*tp_svc_channel_interface_group_get_group_flags_impl) (TpSvcChannelInterfaceGroup *self,
                                                                     DBusGMethodInvocation *context);
void tp_svc_channel_interface_group_implement_get_group_flags (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_group_flags_impl impl);


/**
 * tp_svc_channel_interface_group_return_from_get_group_flags:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_group_return_from_get_group_flags (DBusGMethodInvocation *dbus_context,
                                                            guint ret)
;
static inline void
tp_svc_channel_interface_group_return_from_get_group_flags (DBusGMethodInvocation *dbus_context,
                                                            guint ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_interface_group_get_handle_owners_impl) (TpSvcChannelInterfaceGroup *self,
                                                                       const GArray *handles,
                                                                       DBusGMethodInvocation *context);
void tp_svc_channel_interface_group_implement_get_handle_owners (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_handle_owners_impl impl);


/**
 * tp_svc_channel_interface_group_return_from_get_handle_owners:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_group_return_from_get_handle_owners (DBusGMethodInvocation *dbus_context,
                                                              const GArray *ret)
;
static inline void
tp_svc_channel_interface_group_return_from_get_handle_owners (DBusGMethodInvocation *dbus_context,
                                                              const GArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_interface_group_get_local_pending_members_impl) (TpSvcChannelInterfaceGroup *self,
                                                                               DBusGMethodInvocation *context);
void tp_svc_channel_interface_group_implement_get_local_pending_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_local_pending_members_impl impl);


/**
 * tp_svc_channel_interface_group_return_from_get_local_pending_members:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_group_return_from_get_local_pending_members (DBusGMethodInvocation *dbus_context,
                                                                      const GArray *ret)
;
static inline void
tp_svc_channel_interface_group_return_from_get_local_pending_members (DBusGMethodInvocation *dbus_context,
                                                                      const GArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_interface_group_get_local_pending_members_with_info_impl) (TpSvcChannelInterfaceGroup *self,
                                                                                         DBusGMethodInvocation *context);
void tp_svc_channel_interface_group_implement_get_local_pending_members_with_info (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_local_pending_members_with_info_impl impl);


/**
 * tp_svc_channel_interface_group_return_from_get_local_pending_members_with_info:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_group_return_from_get_local_pending_members_with_info (DBusGMethodInvocation *dbus_context,
                                                                                const GPtrArray *ret)
;
static inline void
tp_svc_channel_interface_group_return_from_get_local_pending_members_with_info (DBusGMethodInvocation *dbus_context,
                                                                                const GPtrArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_interface_group_get_members_impl) (TpSvcChannelInterfaceGroup *self,
                                                                 DBusGMethodInvocation *context);
void tp_svc_channel_interface_group_implement_get_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_members_impl impl);


/**
 * tp_svc_channel_interface_group_return_from_get_members:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_group_return_from_get_members (DBusGMethodInvocation *dbus_context,
                                                        const GArray *ret)
;
static inline void
tp_svc_channel_interface_group_return_from_get_members (DBusGMethodInvocation *dbus_context,
                                                        const GArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_interface_group_get_remote_pending_members_impl) (TpSvcChannelInterfaceGroup *self,
                                                                                DBusGMethodInvocation *context);
void tp_svc_channel_interface_group_implement_get_remote_pending_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_remote_pending_members_impl impl);


/**
 * tp_svc_channel_interface_group_return_from_get_remote_pending_members:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_group_return_from_get_remote_pending_members (DBusGMethodInvocation *dbus_context,
                                                                       const GArray *ret)
;
static inline void
tp_svc_channel_interface_group_return_from_get_remote_pending_members (DBusGMethodInvocation *dbus_context,
                                                                       const GArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_interface_group_get_self_handle_impl) (TpSvcChannelInterfaceGroup *self,
                                                                     DBusGMethodInvocation *context);
void tp_svc_channel_interface_group_implement_get_self_handle (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_get_self_handle_impl impl);


/**
 * tp_svc_channel_interface_group_return_from_get_self_handle:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_group_return_from_get_self_handle (DBusGMethodInvocation *dbus_context,
                                                            guint ret)
;
static inline void
tp_svc_channel_interface_group_return_from_get_self_handle (DBusGMethodInvocation *dbus_context,
                                                            guint ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_interface_group_remove_members_impl) (TpSvcChannelInterfaceGroup *self,
                                                                    const GArray *contacts,
                                                                    const gchar *message,
                                                                    DBusGMethodInvocation *context);
void tp_svc_channel_interface_group_implement_remove_members (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_remove_members_impl impl);


/**
 * tp_svc_channel_interface_group_return_from_remove_members:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_group_return_from_remove_members (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_channel_interface_group_return_from_remove_members (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_channel_interface_group_remove_members_with_reason_impl) (TpSvcChannelInterfaceGroup *self,
                                                                                const GArray *contacts,
                                                                                const gchar *message,
                                                                                guint reason,
                                                                                DBusGMethodInvocation *context);
void tp_svc_channel_interface_group_implement_remove_members_with_reason (TpSvcChannelInterfaceGroupClass *klass, tp_svc_channel_interface_group_remove_members_with_reason_impl impl);


/**
 * tp_svc_channel_interface_group_return_from_remove_members_with_reason:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_interface_group_return_from_remove_members_with_reason (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_channel_interface_group_return_from_remove_members_with_reason (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void tp_svc_channel_interface_group_emit_group_flags_changed (gpointer instance,
    const guint  added,
    const guint  removed);

void tp_svc_channel_interface_group_emit_members_changed (gpointer instance,
    const gchar * message,
    const GArray * added,
    const GArray * removed,
    const GArray * local_pending,
    const GArray * remote_pending,
    const guint  actor,
    const guint  reason);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CHANNEL_INTERFACE_GROUP_H__*/
