/*
 * _gen/svc-Channel_Type_Text.h - Header for TpSvcChannelTypeText
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CHANNEL_TYPE_TEXT_H__
#define __TP_SVC_CHANNEL_TYPE_TEXT_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcChannelTypeText:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcChannelTypeText TpSvcChannelTypeText;

/**
 * TpSvcChannelTypeTextClass:
 *
 * The class of TpSvcChannelTypeText.
 */
typedef struct _TpSvcChannelTypeTextClass TpSvcChannelTypeTextClass;


GType tp_svc_channel_type_text_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CHANNEL_TYPE_TEXT \
  (tp_svc_channel_type_text_get_type ())
#define TP_SVC_CHANNEL_TYPE_TEXT(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CHANNEL_TYPE_TEXT, TpSvcChannelTypeText))
#define TP_IS_SVC_CHANNEL_TYPE_TEXT(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CHANNEL_TYPE_TEXT))
#define TP_SVC_CHANNEL_TYPE_TEXT_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CHANNEL_TYPE_TEXT, TpSvcChannelTypeTextClass))


typedef void (*tp_svc_channel_type_text_acknowledge_pending_messages_impl) (TpSvcChannelTypeText *self,
                                                                            const GArray *ids,
                                                                            DBusGMethodInvocation *context);
void tp_svc_channel_type_text_implement_acknowledge_pending_messages (TpSvcChannelTypeTextClass *klass, tp_svc_channel_type_text_acknowledge_pending_messages_impl impl);


/**
 * tp_svc_channel_type_text_return_from_acknowledge_pending_messages:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_type_text_return_from_acknowledge_pending_messages (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_channel_type_text_return_from_acknowledge_pending_messages (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_channel_type_text_get_message_types_impl) (TpSvcChannelTypeText *self,
                                                                 DBusGMethodInvocation *context);
void tp_svc_channel_type_text_implement_get_message_types (TpSvcChannelTypeTextClass *klass, tp_svc_channel_type_text_get_message_types_impl impl);


/**
 * tp_svc_channel_type_text_return_from_get_message_types:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_type_text_return_from_get_message_types (DBusGMethodInvocation *dbus_context,
                                                        const GArray *ret)
;
static inline void
tp_svc_channel_type_text_return_from_get_message_types (DBusGMethodInvocation *dbus_context,
                                                        const GArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_type_text_list_pending_messages_impl) (TpSvcChannelTypeText *self,
                                                                     gboolean clear,
                                                                     DBusGMethodInvocation *context);
void tp_svc_channel_type_text_implement_list_pending_messages (TpSvcChannelTypeTextClass *klass, tp_svc_channel_type_text_list_pending_messages_impl impl);


/**
 * tp_svc_channel_type_text_return_from_list_pending_messages:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_type_text_return_from_list_pending_messages (DBusGMethodInvocation *dbus_context,
                                                            const GPtrArray *ret)
;
static inline void
tp_svc_channel_type_text_return_from_list_pending_messages (DBusGMethodInvocation *dbus_context,
                                                            const GPtrArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_channel_type_text_send_impl) (TpSvcChannelTypeText *self,
                                                    guint type,
                                                    const gchar *text,
                                                    DBusGMethodInvocation *context);
void tp_svc_channel_type_text_implement_send (TpSvcChannelTypeTextClass *klass, tp_svc_channel_type_text_send_impl impl);


/**
 * tp_svc_channel_type_text_return_from_send:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_channel_type_text_return_from_send (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_channel_type_text_return_from_send (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void tp_svc_channel_type_text_emit_lost_message (gpointer instance);

void tp_svc_channel_type_text_emit_received (gpointer instance,
    const guint  id,
    const guint  timestamp,
    const guint  sender,
    const guint  type,
    const guint  flags,
    const gchar * text);

void tp_svc_channel_type_text_emit_send_error (gpointer instance,
    const guint  error,
    const guint  timestamp,
    const guint  type,
    const gchar * text);

void tp_svc_channel_type_text_emit_sent (gpointer instance,
    const guint  timestamp,
    const guint  type,
    const gchar * text);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CHANNEL_TYPE_TEXT_H__*/
