/*
 * _gen/svc-Connection.h - Header for TpSvcConnection
 *
 * Copyright (C) 2005, 2006, 2007 Collabora Limited
 * Copyright (C) 2005, 2006 Nokia Corporation
 * Copyright (C) 2006 INdT
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_CONNECTION_H__
#define __TP_SVC_CONNECTION_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcConnection:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcConnection TpSvcConnection;

/**
 * TpSvcConnectionClass:
 *
 * The class of TpSvcConnection.
 */
typedef struct _TpSvcConnectionClass TpSvcConnectionClass;


GType tp_svc_connection_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_CONNECTION \
  (tp_svc_connection_get_type ())
#define TP_SVC_CONNECTION(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_CONNECTION, TpSvcConnection))
#define TP_IS_SVC_CONNECTION(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_CONNECTION))
#define TP_SVC_CONNECTION_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_CONNECTION, TpSvcConnectionClass))


typedef void (*tp_svc_connection_connect_impl) (TpSvcConnection *self,
                                                DBusGMethodInvocation *context);
void tp_svc_connection_implement_connect (TpSvcConnectionClass *klass, tp_svc_connection_connect_impl impl);


/**
 * tp_svc_connection_return_from_connect:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_connect (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_return_from_connect (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_connection_disconnect_impl) (TpSvcConnection *self,
                                                   DBusGMethodInvocation *context);
void tp_svc_connection_implement_disconnect (TpSvcConnectionClass *klass, tp_svc_connection_disconnect_impl impl);


/**
 * tp_svc_connection_return_from_disconnect:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_disconnect (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_return_from_disconnect (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_connection_get_interfaces_impl) (TpSvcConnection *self,
                                                       DBusGMethodInvocation *context);
void tp_svc_connection_implement_get_interfaces (TpSvcConnectionClass *klass, tp_svc_connection_get_interfaces_impl impl);


/**
 * tp_svc_connection_return_from_get_interfaces:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_get_interfaces (DBusGMethodInvocation *dbus_context,
                                              const gchar **ret)
;
static inline void
tp_svc_connection_return_from_get_interfaces (DBusGMethodInvocation *dbus_context,
                                              const gchar **ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_get_protocol_impl) (TpSvcConnection *self,
                                                     DBusGMethodInvocation *context);
void tp_svc_connection_implement_get_protocol (TpSvcConnectionClass *klass, tp_svc_connection_get_protocol_impl impl);


/**
 * tp_svc_connection_return_from_get_protocol:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_get_protocol (DBusGMethodInvocation *dbus_context,
                                            const gchar *ret)
;
static inline void
tp_svc_connection_return_from_get_protocol (DBusGMethodInvocation *dbus_context,
                                            const gchar *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_get_self_handle_impl) (TpSvcConnection *self,
                                                        DBusGMethodInvocation *context);
void tp_svc_connection_implement_get_self_handle (TpSvcConnectionClass *klass, tp_svc_connection_get_self_handle_impl impl);


/**
 * tp_svc_connection_return_from_get_self_handle:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_get_self_handle (DBusGMethodInvocation *dbus_context,
                                               guint ret)
;
static inline void
tp_svc_connection_return_from_get_self_handle (DBusGMethodInvocation *dbus_context,
                                               guint ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_get_status_impl) (TpSvcConnection *self,
                                                   DBusGMethodInvocation *context);
void tp_svc_connection_implement_get_status (TpSvcConnectionClass *klass, tp_svc_connection_get_status_impl impl);


/**
 * tp_svc_connection_return_from_get_status:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_get_status (DBusGMethodInvocation *dbus_context,
                                          guint ret)
;
static inline void
tp_svc_connection_return_from_get_status (DBusGMethodInvocation *dbus_context,
                                          guint ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_hold_handles_impl) (TpSvcConnection *self,
                                                     guint handle_type,
                                                     const GArray *handles,
                                                     DBusGMethodInvocation *context);
void tp_svc_connection_implement_hold_handles (TpSvcConnectionClass *klass, tp_svc_connection_hold_handles_impl impl);


/**
 * tp_svc_connection_return_from_hold_handles:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_hold_handles (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_return_from_hold_handles (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_connection_inspect_handles_impl) (TpSvcConnection *self,
                                                        guint handle_type,
                                                        const GArray *handles,
                                                        DBusGMethodInvocation *context);
void tp_svc_connection_implement_inspect_handles (TpSvcConnectionClass *klass, tp_svc_connection_inspect_handles_impl impl);


/**
 * tp_svc_connection_return_from_inspect_handles:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_inspect_handles (DBusGMethodInvocation *dbus_context,
                                               const gchar **ret)
;
static inline void
tp_svc_connection_return_from_inspect_handles (DBusGMethodInvocation *dbus_context,
                                               const gchar **ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_list_channels_impl) (TpSvcConnection *self,
                                                      DBusGMethodInvocation *context);
void tp_svc_connection_implement_list_channels (TpSvcConnectionClass *klass, tp_svc_connection_list_channels_impl impl);


/**
 * tp_svc_connection_return_from_list_channels:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_list_channels (DBusGMethodInvocation *dbus_context,
                                             const GPtrArray *ret)
;
static inline void
tp_svc_connection_return_from_list_channels (DBusGMethodInvocation *dbus_context,
                                             const GPtrArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_release_handles_impl) (TpSvcConnection *self,
                                                        guint handle_type,
                                                        const GArray *handles,
                                                        DBusGMethodInvocation *context);
void tp_svc_connection_implement_release_handles (TpSvcConnectionClass *klass, tp_svc_connection_release_handles_impl impl);


/**
 * tp_svc_connection_return_from_release_handles:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_release_handles (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_connection_return_from_release_handles (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_connection_request_channel_impl) (TpSvcConnection *self,
                                                        const gchar *type,
                                                        guint handle_type,
                                                        guint handle,
                                                        gboolean suppress_handler,
                                                        DBusGMethodInvocation *context);
void tp_svc_connection_implement_request_channel (TpSvcConnectionClass *klass, tp_svc_connection_request_channel_impl impl);


/**
 * tp_svc_connection_return_from_request_channel:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_request_channel (DBusGMethodInvocation *dbus_context,
                                               const gchar *ret)
;
static inline void
tp_svc_connection_return_from_request_channel (DBusGMethodInvocation *dbus_context,
                                               const gchar *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_connection_request_handles_impl) (TpSvcConnection *self,
                                                        guint handle_type,
                                                        const gchar **names,
                                                        DBusGMethodInvocation *context);
void tp_svc_connection_implement_request_handles (TpSvcConnectionClass *klass, tp_svc_connection_request_handles_impl impl);


/**
 * tp_svc_connection_return_from_request_handles:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_connection_return_from_request_handles (DBusGMethodInvocation *dbus_context,
                                               const GArray *ret)
;
static inline void
tp_svc_connection_return_from_request_handles (DBusGMethodInvocation *dbus_context,
                                               const GArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
void tp_svc_connection_emit_new_channel (gpointer instance,
    const gchar * object_path,
    const gchar * channel_type,
    const guint  handle_type,
    const guint  handle,
    const gboolean  suppress_handler);

void tp_svc_connection_emit_status_changed (gpointer instance,
    const guint  status,
    const guint  reason);



G_END_DECLS

#endif /* #ifndef __TP_SVC_CONNECTION_H__*/
