/*
 * _gen/svc-Media_Stream_Handler.h - Header for TpSvcMediaStreamHandler
 *
 *  Copyright (C) 2005, 2006 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_MEDIA_STREAM_HANDLER_H__
#define __TP_SVC_MEDIA_STREAM_HANDLER_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcMediaStreamHandler:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcMediaStreamHandler TpSvcMediaStreamHandler;

/**
 * TpSvcMediaStreamHandlerClass:
 *
 * The class of TpSvcMediaStreamHandler.
 */
typedef struct _TpSvcMediaStreamHandlerClass TpSvcMediaStreamHandlerClass;


GType tp_svc_media_stream_handler_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_MEDIA_STREAM_HANDLER \
  (tp_svc_media_stream_handler_get_type ())
#define TP_SVC_MEDIA_STREAM_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_MEDIA_STREAM_HANDLER, TpSvcMediaStreamHandler))
#define TP_IS_SVC_MEDIA_STREAM_HANDLER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_MEDIA_STREAM_HANDLER))
#define TP_SVC_MEDIA_STREAM_HANDLER_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_MEDIA_STREAM_HANDLER, TpSvcMediaStreamHandlerClass))


typedef void (*tp_svc_media_stream_handler_codec_choice_impl) (TpSvcMediaStreamHandler *self,
                                                               guint codec_id,
                                                               DBusGMethodInvocation *context);
void tp_svc_media_stream_handler_implement_codec_choice (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_codec_choice_impl impl);


/**
 * tp_svc_media_stream_handler_return_from_codec_choice:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_media_stream_handler_return_from_codec_choice (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_media_stream_handler_return_from_codec_choice (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_media_stream_handler_error_impl) (TpSvcMediaStreamHandler *self,
                                                        guint errno,
                                                        const gchar *message,
                                                        DBusGMethodInvocation *context);
void tp_svc_media_stream_handler_implement_error (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_error_impl impl);


/**
 * tp_svc_media_stream_handler_return_from_error:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_media_stream_handler_return_from_error (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_media_stream_handler_return_from_error (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_media_stream_handler_native_candidates_prepared_impl) (TpSvcMediaStreamHandler *self,
                                                                             DBusGMethodInvocation *context);
void tp_svc_media_stream_handler_implement_native_candidates_prepared (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_native_candidates_prepared_impl impl);


/**
 * tp_svc_media_stream_handler_return_from_native_candidates_prepared:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_media_stream_handler_return_from_native_candidates_prepared (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_media_stream_handler_return_from_native_candidates_prepared (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_media_stream_handler_new_active_candidate_pair_impl) (TpSvcMediaStreamHandler *self,
                                                                            const gchar *native_candidate_id,
                                                                            const gchar *remote_candidate_id,
                                                                            DBusGMethodInvocation *context);
void tp_svc_media_stream_handler_implement_new_active_candidate_pair (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_new_active_candidate_pair_impl impl);


/**
 * tp_svc_media_stream_handler_return_from_new_active_candidate_pair:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_media_stream_handler_return_from_new_active_candidate_pair (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_media_stream_handler_return_from_new_active_candidate_pair (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_media_stream_handler_new_native_candidate_impl) (TpSvcMediaStreamHandler *self,
                                                                       const gchar *candidate_id,
                                                                       const GPtrArray *transports,
                                                                       DBusGMethodInvocation *context);
void tp_svc_media_stream_handler_implement_new_native_candidate (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_new_native_candidate_impl impl);


/**
 * tp_svc_media_stream_handler_return_from_new_native_candidate:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_media_stream_handler_return_from_new_native_candidate (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_media_stream_handler_return_from_new_native_candidate (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_media_stream_handler_ready_impl) (TpSvcMediaStreamHandler *self,
                                                        const GPtrArray *codecs,
                                                        DBusGMethodInvocation *context);
void tp_svc_media_stream_handler_implement_ready (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_ready_impl impl);


/**
 * tp_svc_media_stream_handler_return_from_ready:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_media_stream_handler_return_from_ready (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_media_stream_handler_return_from_ready (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_media_stream_handler_set_local_codecs_impl) (TpSvcMediaStreamHandler *self,
                                                                   const GPtrArray *codecs,
                                                                   DBusGMethodInvocation *context);
void tp_svc_media_stream_handler_implement_set_local_codecs (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_set_local_codecs_impl impl);


/**
 * tp_svc_media_stream_handler_return_from_set_local_codecs:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_media_stream_handler_return_from_set_local_codecs (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_media_stream_handler_return_from_set_local_codecs (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_media_stream_handler_stream_state_impl) (TpSvcMediaStreamHandler *self,
                                                               guint state,
                                                               DBusGMethodInvocation *context);
void tp_svc_media_stream_handler_implement_stream_state (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_stream_state_impl impl);


/**
 * tp_svc_media_stream_handler_return_from_stream_state:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_media_stream_handler_return_from_stream_state (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_media_stream_handler_return_from_stream_state (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
typedef void (*tp_svc_media_stream_handler_supported_codecs_impl) (TpSvcMediaStreamHandler *self,
                                                                   const GPtrArray *codecs,
                                                                   DBusGMethodInvocation *context);
void tp_svc_media_stream_handler_implement_supported_codecs (TpSvcMediaStreamHandlerClass *klass, tp_svc_media_stream_handler_supported_codecs_impl impl);


/**
 * tp_svc_media_stream_handler_return_from_supported_codecs:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_media_stream_handler_return_from_supported_codecs (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_media_stream_handler_return_from_supported_codecs (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void tp_svc_media_stream_handler_emit_add_remote_candidate (gpointer instance,
    const gchar * candidate_id,
    const GPtrArray * transports);

void tp_svc_media_stream_handler_emit_close (gpointer instance);

void tp_svc_media_stream_handler_emit_remove_remote_candidate (gpointer instance,
    const gchar * candidate_id);

void tp_svc_media_stream_handler_emit_set_active_candidate_pair (gpointer instance,
    const gchar * native_candidate_id,
    const gchar * remote_candidate_id);

void tp_svc_media_stream_handler_emit_set_remote_candidate_list (gpointer instance,
    const GPtrArray * remote_candidates);

void tp_svc_media_stream_handler_emit_set_remote_codecs (gpointer instance,
    const GPtrArray * codecs);

void tp_svc_media_stream_handler_emit_set_stream_playing (gpointer instance,
    const gboolean  playing);

void tp_svc_media_stream_handler_emit_set_stream_sending (gpointer instance,
    const gboolean  sending);

void tp_svc_media_stream_handler_emit_start_telephony_event (gpointer instance,
    const guchar  event);

void tp_svc_media_stream_handler_emit_stop_telephony_event (gpointer instance);



G_END_DECLS

#endif /* #ifndef __TP_SVC_MEDIA_STREAM_HANDLER_H__*/
