/*
 * _gen/svc-Properties_Interface.h - Header for TpSvcPropertiesInterface
 *
 *  Copyright (C) 2005-2007 Collabora Limited 
 *  Copyright (C) 2005, 2006 Nokia Corporation 
 *  Copyright (C) 2006 INdT 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#ifndef __TP_SVC_PROPERTIES_INTERFACE_H__
#define __TP_SVC_PROPERTIES_INTERFACE_H__

#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * TpSvcPropertiesInterface:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _TpSvcPropertiesInterface TpSvcPropertiesInterface;

/**
 * TpSvcPropertiesInterfaceClass:
 *
 * The class of TpSvcPropertiesInterface.
 */
typedef struct _TpSvcPropertiesInterfaceClass TpSvcPropertiesInterfaceClass;


GType tp_svc_properties_interface_get_type (void);

/* TYPE MACROS */
#define TP_TYPE_SVC_PROPERTIES_INTERFACE \
  (tp_svc_properties_interface_get_type ())
#define TP_SVC_PROPERTIES_INTERFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), TP_TYPE_SVC_PROPERTIES_INTERFACE, TpSvcPropertiesInterface))
#define TP_IS_SVC_PROPERTIES_INTERFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), TP_TYPE_SVC_PROPERTIES_INTERFACE))
#define TP_SVC_PROPERTIES_INTERFACE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TP_TYPE_SVC_PROPERTIES_INTERFACE, TpSvcPropertiesInterfaceClass))


typedef void (*tp_svc_properties_interface_get_properties_impl) (TpSvcPropertiesInterface *self,
                                                                 const GArray *properties,
                                                                 DBusGMethodInvocation *context);
void tp_svc_properties_interface_implement_get_properties (TpSvcPropertiesInterfaceClass *klass, tp_svc_properties_interface_get_properties_impl impl);


/**
 * tp_svc_properties_interface_return_from_get_properties:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_properties_interface_return_from_get_properties (DBusGMethodInvocation *dbus_context,
                                                        const GPtrArray *ret)
;
static inline void
tp_svc_properties_interface_return_from_get_properties (DBusGMethodInvocation *dbus_context,
                                                        const GPtrArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_properties_interface_list_properties_impl) (TpSvcPropertiesInterface *self,
                                                                  DBusGMethodInvocation *context);
void tp_svc_properties_interface_implement_list_properties (TpSvcPropertiesInterfaceClass *klass, tp_svc_properties_interface_list_properties_impl impl);


/**
 * tp_svc_properties_interface_return_from_list_properties:
 * @dbus_context: The D-Bus method invocation context
 * @ret: FIXME: document args in genginterface
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_properties_interface_return_from_list_properties (DBusGMethodInvocation *dbus_context,
                                                         const GPtrArray *ret)
;
static inline void
tp_svc_properties_interface_return_from_list_properties (DBusGMethodInvocation *dbus_context,
                                                         const GPtrArray *ret)
{
  dbus_g_method_return (dbus_context, ret);
}
typedef void (*tp_svc_properties_interface_set_properties_impl) (TpSvcPropertiesInterface *self,
                                                                 const GPtrArray *properties,
                                                                 DBusGMethodInvocation *context);
void tp_svc_properties_interface_implement_set_properties (TpSvcPropertiesInterfaceClass *klass, tp_svc_properties_interface_set_properties_impl impl);


/**
 * tp_svc_properties_interface_return_from_set_properties:
 * @dbus_context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return (@dbus_context,
 * ...). This inline function is just a type-safe wrapper for
 * dbus_g_method_return.
 */
static inline
/**/
void
tp_svc_properties_interface_return_from_set_properties (DBusGMethodInvocation *dbus_context)
;
static inline void
tp_svc_properties_interface_return_from_set_properties (DBusGMethodInvocation *dbus_context)
{
  dbus_g_method_return (dbus_context);
}
void tp_svc_properties_interface_emit_properties_changed (gpointer instance,
    const GPtrArray * properties);

void tp_svc_properties_interface_emit_property_flags_changed (gpointer instance,
    const GPtrArray * properties);



G_END_DECLS

#endif /* #ifndef __TP_SVC_PROPERTIES_INTERFACE_H__*/
